Attribute VB_Name = "mdlGame"

'The images used in this sample
Dim imgBg As KSurface, imgFg As KSurface

'The effect that we're currently using (so you can cycle trough them all)
'I had to make another variable, CurEffect2, because when you press the A or
'S keys it cycles trough them too fast! This is not important for the demo
'so I don't think it needs an explanation :p
Dim CurrentEffect As Long, CurEffect2 As Long

'The current position of the source image
Dim FgX As Long, FgY As Long



'Set this to True to exit the game
Global ExitGame As Boolean



'This is to calculate the FPS:
Public Declare Function GetTickCount Lib "kernel32" () As Long
Dim LastTick As Long, NumFrames As Long, CurrentFPS As Long



Sub Main()
    'Set the display size
    ScreenX = 384 '480
    ScreenY = 288 '360
    
    'Initialize DirectX
    InitializeDX ScreenX, ScreenY
    
    'Set the draw color to black...
    Backbuffer.SURF.SetForeColor vbBlack
    
    
    'Load the images...
    '
    'I used an optional last parameter, which allows you to choose wheter
    'the surface will be loaded to video memory or not.
    'When it's loaded to video memory, using GetLockedArray() will be
    'about 2x faster! But if you use this for regular Blt, it'll be
    '2x slower :p
    '
    'So choose well. Leave the parameter blank for regular surfaces, and
    'set it to True for special effects.
    
    'The background...
    LoadSurface App.Path & "\bg.bmp", imgBg, 384, 288
    'The effect... notice the last parameter set to True ;)
    LoadSurface App.Path & "\fg.bmp", imgFg, 46, 50, True
    
    
    'Center the source image at first...
    FgX = 169
    FgY = 119
    
    
    'Initialize the effects (IMPORTANT)
    InitialiseSpecialEffects
    
    
    ExitGame = False
    frmGame.Show
    'Program loop -------------------------------------------------
    Do While ExitGame = False
        DoEvents
        
        'Calculate the FPS...
        NumFrames = NumFrames + 1
        If GetTickCount() >= LastTick + 1000 Then
            CurrentFPS = NumFrames
            
            LastTick = GetTickCount()
            NumFrames = 0
        End If
        
        
        
        'Use the keyboard object provided by InitializeDX
        Keyboard.Acquire
        Keyboard.GetDeviceStateKeyboard KeyboardState
        'Check the keys...
        If CheckKey(DIK_ESCAPE) Then ExitGame = True 'Exit program
        If CheckKey(DIK_A) And CurrentEffect > 0 Then CurEffect2 = CurEffect2 - 1 'Use the previous effect
        If CheckKey(DIK_S) And CurrentEffect < 17 Then CurEffect2 = CurEffect2 + 1 'Use the next effect
        If CheckKey(DIK_LEFT) Then FgX = FgX - 2 'Move the source image left
        If CheckKey(DIK_RIGHT) Then FgX = FgX + 2 'Move the source image right
        If CheckKey(DIK_UP) Then FgY = FgY - 2 'Move the source image up
        If CheckKey(DIK_DOWN) Then FgY = FgY + 2 'Move the source image down
        If CheckKey(DIK_C) Then FgX = 169: FgY = 119 'Center the image again
        
        'NOTE: This is NOT important for the effects demo, as well as the above
        'keys and FPS stuff :)
        CurrentEffect = CurEffect2 / 25
        
        
        
        'Draw a nice background using regular blt...
        Blt imgBg, Backbuffer, 0, 0, 0, 0, 384, 288, False
        
        'Draw an atom using the special effect YOU selected ;)
        SpecialBlt imgFg.SURF, imgFg.DESC, Backbuffer.SURF, Backbuffer.DESC, FgX, FgY, 0, 0, 46, 50, CurrentEffect
        
        
        
        'Print the instructions and the FPS... not very important too
        On Error Resume Next
        Backbuffer.SURF.DrawText 0, 0, "The keys A and S cycle between effects.", False
        Backbuffer.SURF.DrawText 0, 12, "Arrow keys move the source image.", False
        Backbuffer.SURF.DrawText 0, 24, "C centers the source image, in case you lose it!", False
        Backbuffer.SURF.DrawText 0, 36, "Escape exits.", False
        Backbuffer.SURF.DrawText 0, 260, "Current lookup table index (effect): " & CurrentEffect & ".", False
        Backbuffer.SURF.DrawText 0, 272, "Running at " & CurrentFPS & " frames per second.", False
        On Error GoTo 0
        
        'Flip the screen to apply the changes
        Flip
    Loop
    '--------------------------------------------------------------
    
    
errOut:
    'Exit the program, turn off directX and clean up
    CloseDX
End Sub

'Returns True if a key was pressed...
Public Function CheckKey(Key As Byte) As Boolean
    If (KeyboardState.Key(Key) And &H80) <> 0 Then CheckKey = True
End Function
